#include <stdio.h>
#include <ftdi.h>

typedef struct
{
  unsigned short vid;
  unsigned short pid;
  const char *desc;  
} FTDI_DEVICE_INFO_ST;

static const FTDI_DEVICE_INFO_ST device_info_list[] =
{
  { 0x0403, 0x6001, "Generic FTDI USB Device" },
  { 0x0403, 0xD968, "Pro-Active Generic USB Device" },
  { 0x0403, 0xD969, "Pro-Active CSB USB Coupler" },
  { 0x0403, 0xD96A, "Pro-Active RFU" },
  { 0x0403, 0xD96B, "Pro-Active RFU" },
  { 0x0403, 0xD96C, "Pro-Active RFU" },
  { 0x0403, 0xD96D, "Pro-Active RFU" },
  { 0x0403, 0xD96E, "Pro-Active RFU" },
  { 0x0403, 0xD96F, "Pro-Active RFU" }
};


int main(int argc, char **argv)
{
  int ret, i, c = 0;
  struct ftdi_context ftdic;
  ftdi_init(&ftdic);
  
  for (i=0; i<sizeof(device_info_list)/sizeof(FTDI_DEVICE_INFO_ST); i++)
  {
    ret = ftdi_usb_open(&ftdic, device_info_list[i].vid, device_info_list[i].pid);
    if (ret >= 0)
    {
      printf("Found device FTDI:%04X:%04X\n", device_info_list[i].vid, device_info_list[i].pid);
      printf("\t--> %s\n", device_info_list[i].desc);
      ftdi_usb_close(&ftdic);

      c++;  
    }
  }

  ftdi_deinit(&ftdic);
  
  if (c)
  {
    printf("%d supported device(s) found\n", c);
    return EXIT_SUCCESS;
  }
  
  printf("None of the supported devices have been found\n");
  return EXIT_FAILURE;
}

