/*
  THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.

  SpringProx API
  --------------

  Copyright (c) 2000-2006 Pro-Active SAS - www.pro-active.fr

  sprox_serial.h
  --------------
  Serial communication prototypes

*/
#ifndef SPROX_SERIAL_H
#define SPROX_SERIAL_H

BOOL    SendByte(SPROX_CTX_ST *sprox_ctx, BYTE b);
BOOL    SendBurst(SPROX_CTX_ST *sprox_ctx, BYTE *b, WORD len);
BOOL    RecvByte(SPROX_CTX_ST *sprox_ctx, BYTE *b);
BOOL    RecvBurst(SPROX_CTX_ST *sprox_ctx, BYTE *b, WORD len);

BOOL    SerialSetTimeouts(SPROX_CTX_ST *sprox_ctx, DWORD resp_tmo, DWORD byte_tmo);
BOOL    SerialSetBaudrate(SPROX_CTX_ST *sprox_ctx, DWORD baudrate);
BOOL    SerialLookup(SPROX_CTX_ST *sprox_ctx);

BOOL    SerialOpen(SPROX_CTX_ST *sprox_ctx, const TCHAR *device);
void    SerialClose(SPROX_CTX_ST *sprox_ctx);
BOOL    SerialPowerUp(SPROX_CTX_ST *sprox_ctx);
BOOL    SerialPowerDown(SPROX_CTX_ST *sprox_ctx);
BOOL    SerialReset(SPROX_CTX_ST *sprox_ctx);

#define INTER_BYTE_TMO     200  /* Timeout between each byte        (ms) */
#define OSI_PROTOCOL_TMO   500  /* Timeout for the OSI flow control (ms) */
#define ASCII_TMO         5000  /* Timeout for the ASCII protocol   (ms) */
#define RESPONSE_TMO      1200  /* Timeout between send and receive (ms) */

#endif
