#include "springprox.h"

#include <stdio.h>
#include <string.h>
#include <errno.h>
#ifdef __linux
#include <netinet/in.h>
#endif

#include "fingertk.h"

void save_to_file(FINGERTK_DATA_ST *data)
{
  FINGERTK_DATA_ST data_copy = *data;
  char fname[256] = "";
  size_t rc;
  FILE *fp;

  printf("Saving user's data to a file\n");

  /* Get filename */
  printf("Enter file name: ");
  if ((fgets(fname, sizeof(fname), stdin) == NULL) || (strlen(fname) == 0))
  {
    printf("Cancelled\n");
    return;
  }

  /* Preserve WORD orders */
  data_copy.finger1_len = htons(data_copy.finger1_len);
  data_copy.finger2_len = htons(data_copy.finger2_len);

  fp = fopen(fname, "wb");
  if (fp == NULL)
  {
    printf("Failed to open file for writing ; operation cancelled\n");
    return;
  }

  rc = fwrite(&data_copy, 1, sizeof(FINGERTK_DATA_ST), fp);
  if (rc < sizeof(FINGERTK_DATA_ST))
  {
    printf("File error during writing (%d)\n", errno);
    fclose(fp);
    return;
  }
  fclose(fp);

  /* Done */
  printf("Data have been saved to the file\n");
}

BOOL load_from_file(FINGERTK_DATA_ST *data)
{
  FINGERTK_DATA_ST data_read;
  char fname[256] = "";
  size_t rc;
  FILE *fp;
  
  memset(&data_read, 0, sizeof(data_read));

  printf("Loading user's data from a file\n");

  /* Get filename */
  printf("Enter file name: ");
  if ((fgets(fname, sizeof(fname), stdin) == NULL) || (strlen(fname) == 0))
  {
    printf("Cancelled\n");
    return FALSE;
  }

  /* Open and read the file */
  fp = fopen(fname, "rb");
  if (fp == NULL)
  {
    printf("Failed to open file for reading ; operation cancelled\n");
    return FALSE;
  }

  rc = fread(&data_read, 1, sizeof(FINGERTK_DATA_ST), fp);
  if (rc < sizeof(FINGERTK_DATA_ST))
  {
    printf("File error during reading (%d)\n", errno);
    fclose(fp);
    return FALSE;
  }
  fclose(fp);

  /* Preserve WORD orders */
  data_read.finger1_len = ntohs(data_read.finger1_len);
  data_read.finger2_len = ntohs(data_read.finger2_len);

  /* Done */
  *data = data_read;
  printf("Data have been loaded from the file\n");
  return TRUE;
}

